//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3992F73C01FB.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3992F73C01FB.cm

//## begin module%3992F73C01FB.cp preserve=no
//## end module%3992F73C01FB.cp

//## Module: DataFactory%3992F73C01FB; Package specification
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/DataFactory/DataFactory.h

#ifndef DATAFACTORY_H
#define DATAFACTORY_H 1

//## begin module%3992F73C01FB.additionalIncludes preserve=no
//## end module%3992F73C01FB.additionalIncludes

//## begin module%3992F73C01FB.includes preserve=yes
//## end module%3992F73C01FB.includes


class DataSet;
class BackCorr;
class Response;

//## begin module%3992F73C01FB.declarations preserve=no
//## end module%3992F73C01FB.declarations

//## begin module%3992F73C01FB.additionalDeclarations preserve=yes
typedef BackCorr Correction;
typedef BackCorr Background;
//## end module%3992F73C01FB.additionalDeclarations


//## begin DataFactory%3992ECC901AB.preface preserve=yes
//## end DataFactory%3992ECC901AB.preface

//## Class: DataFactory%3992ECC901AB
//	Class implementing an abstract Factory for datasets
//	and their associated files.
//## Category: XSModel::DataFactory%399415D40147
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39FF36670325;BackCorr { -> F}

class DataFactory 
{
  //## begin DataFactory%3992ECC901AB.initialDeclarations preserve=yes
  //## end DataFactory%3992ECC901AB.initialDeclarations

  public:
    //## Destructor (generated)
      virtual ~DataFactory();


    //## Other Operations (specified)
      //## Operation: MakeDataSet%3992F5FB03D2
      virtual DataSet* MakeDataSet () const = 0;

      //## Operation: MakeResponse%39942BBA013B
      virtual Response* MakeResponse () const = 0;

      //## Operation: MakeBackground%39942BF30142
      virtual Background* MakeBackground () const = 0;

      //## Operation: MakeCorrection%39942C51009B
      virtual Correction* MakeCorrection () const = 0;

    // Additional Public Declarations
      //## begin DataFactory%3992ECC901AB.public preserve=yes
      //## end DataFactory%3992ECC901AB.public

  protected:
    //## Constructors (generated)
      DataFactory();

    // Additional Protected Declarations
      //## begin DataFactory%3992ECC901AB.protected preserve=yes
      //## end DataFactory%3992ECC901AB.protected

  private:
    //## Constructors (generated)
      DataFactory(const DataFactory &right);

    //## Assignment Operation (generated)
      DataFactory & operator=(const DataFactory &right);

    // Additional Private Declarations
      //## begin DataFactory%3992ECC901AB.private preserve=yes
      //## end DataFactory%3992ECC901AB.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin DataFactory%3992ECC901AB.implementation preserve=yes
      //## end DataFactory%3992ECC901AB.implementation

};

//## begin DataFactory%3992ECC901AB.postscript preserve=yes
//## end DataFactory%3992ECC901AB.postscript

//## Class: DataPrototype%39A3D63A024C
//	Data Prototype class. Has pointers to concrete objects.
//## Category: XSModel::DataFactory%399415D40147
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class DataPrototype : public DataFactory  //## Inherits: <unnamed>%39A3D64A01CB
{
  public:
    //## Constructors (generated)
      DataPrototype(const DataPrototype &right);

    //## Constructors (specified)
      //## Operation: DataPrototype%39A3DBE50232
      DataPrototype (DataSet* pDataSet, Response* pResponse, Background* pBackground, Correction* pCorrection = 0);

    //## Destructor (generated)
      virtual ~DataPrototype();

    //## Assignment Operation (generated)
      DataPrototype & operator=(const DataPrototype &right);


    //## Other Operations (specified)
      //## Operation: MakeDataSet%39D0CFB30313
      virtual DataSet* MakeDataSet () const;

      //## Operation: MakeResponse%39D0CFB703DC
      virtual Response* MakeResponse () const;

      //## Operation: MakeBackground%39D0CFC10214
      virtual Background* MakeBackground () const;

      //## Operation: MakeCorrection%39D0CFC60316
      virtual Correction* MakeCorrection () const;

  protected:
  private:

    //## Other Operations (specified)
      //## Operation: swap%39E32A250189
      //## Exceptions: ()
      void swap (DataPrototype& right) throw ();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::DataFactory::Background Prototyper%39F8858100FD
      //## Role: DataPrototype::protoBackground%39F8858100FE
      Background* protoBackground ();
      void protoBackground (Background* value);

      //## Association: XSModel::DataFactory::Correction Prototyper%39F886A50229
      //## Role: DataPrototype::protoCorrection%39F886A60344
      Correction* protoCorrection ();
      void protoCorrection (Correction* value);

      //## Association: XSModel::DataFactory::DataSet prototyper%3ACCEAAF01CC
      //## Role: DataPrototype::protoDataSet%3ACCEAB00159
      DataSet* protoDataSet ();
      void protoDataSet (DataSet* value);

      //## Association: XSModel::DataFactory::Response Prototyper%3ACCEBC100DB
      //## Role: DataPrototype::protoResponse%3ACCEBC100DC
      Response* protoResponse ();
      void protoResponse (Response* value);

  private: //## implementation
    // Data Members for Associations

      //## Association: XSModel::DataFactory::Background Prototyper%39F8858100FD
      //## begin DataPrototype::protoBackground%39F8858100FE.role preserve=no  private: Background { -> 1RFHgN}
      Background* m_protoBackground;
      //## end DataPrototype::protoBackground%39F8858100FE.role

      //## Association: XSModel::DataFactory::Correction Prototyper%39F886A50229
      //## begin DataPrototype::protoCorrection%39F886A60344.role preserve=no  private: Correction { -> 1RFHgN}
      Correction* m_protoCorrection;
      //## end DataPrototype::protoCorrection%39F886A60344.role

      //## Association: XSModel::DataFactory::DataSet prototyper%3ACCEAAF01CC
      //## begin DataPrototype::protoDataSet%3ACCEAB00159.role preserve=no  private: DataSet { -> 1RFHgN}
      DataSet* m_protoDataSet;
      //## end DataPrototype::protoDataSet%3ACCEAB00159.role

      //## Association: XSModel::DataFactory::Response Prototyper%3ACCEBC100DB
      //## begin DataPrototype::protoResponse%3ACCEBC100DC.role preserve=no  private: Response { -> 1RFHgN}
      Response* m_protoResponse;
      //## end DataPrototype::protoResponse%3ACCEBC100DC.role

  //## begin DataPrototype%39A3D63A024C.friends preserve=no
    friend class XspecRegistry;
  //## end DataPrototype%39A3D63A024C.friends
};

// Class DataFactory 

// Class DataPrototype 

//## Get and Set Operations for Associations (inline)

inline Background* DataPrototype::protoBackground ()
{
  //## begin DataPrototype::protoBackground%39F8858100FE.get preserve=no
  return m_protoBackground;
  //## end DataPrototype::protoBackground%39F8858100FE.get
}

inline void DataPrototype::protoBackground (Background* value)
{
  //## begin DataPrototype::protoBackground%39F8858100FE.set preserve=no
  m_protoBackground = value;
  //## end DataPrototype::protoBackground%39F8858100FE.set
}

inline Correction* DataPrototype::protoCorrection ()
{
  //## begin DataPrototype::protoCorrection%39F886A60344.get preserve=no
  return m_protoCorrection;
  //## end DataPrototype::protoCorrection%39F886A60344.get
}

inline void DataPrototype::protoCorrection (Correction* value)
{
  //## begin DataPrototype::protoCorrection%39F886A60344.set preserve=no
  m_protoCorrection = value;
  //## end DataPrototype::protoCorrection%39F886A60344.set
}

inline DataSet* DataPrototype::protoDataSet ()
{
  //## begin DataPrototype::protoDataSet%3ACCEAB00159.get preserve=no
  return m_protoDataSet;
  //## end DataPrototype::protoDataSet%3ACCEAB00159.get
}

inline void DataPrototype::protoDataSet (DataSet* value)
{
  //## begin DataPrototype::protoDataSet%3ACCEAB00159.set preserve=no
  m_protoDataSet = value;
  //## end DataPrototype::protoDataSet%3ACCEAB00159.set
}

inline Response* DataPrototype::protoResponse ()
{
  //## begin DataPrototype::protoResponse%3ACCEBC100DC.get preserve=no
  return m_protoResponse;
  //## end DataPrototype::protoResponse%3ACCEBC100DC.get
}

inline void DataPrototype::protoResponse (Response* value)
{
  //## begin DataPrototype::protoResponse%3ACCEBC100DC.set preserve=no
  m_protoResponse = value;
  //## end DataPrototype::protoResponse%3ACCEBC100DC.set
}

//## begin module%3992F73C01FB.epilog preserve=yes
//## end module%3992F73C01FB.epilog


#endif
